Codeforces Round 949 (Div. 2)(A,B题解)

这场真是给我打的汗流浃背了,这场真的巨难(可能是因为我二进制根本就没学好的原因吧)

反正总共就搞了两道题,第一道题注重于思维,第二道题纯二进制,第三道题看着也是二进制(最后时间不够了,没做完,其实时间够我也做不出来,二进制对我来说太难了)

废话不多说直接看这次比赛的题

A. Turtle and Piggy Are Playing a Game

题解:这题就是说给我一个区间,让我找到这个区间里面因子最多的,当时考试的时候我想的是,既然因子最少的,那我就直接去考虑这个区间里面谁是最大的2的次方,因为2*2*2肯定·被包括在2*2*n(N>2),因此我们就可以用stl里面自带的lower_bound去找这个区间里面最大的2的次方

cpp 复制代码
#include<bits/stdc++.h>
using namespace std;
#define int long long
int t;
int l,r;
int a[40];
signed main()
{
	cin>>t;
	int ans=1;
	for(int i=1;i<=32;i++)
	{
		ans*=2;
		a[i]=ans;
	}
	while(t--)
	{
		cin>>l>>r;
		int flag=lower_bound(a+1,a+32+1,r)-a;
		if(a[flag]==r)
		cout<<flag<<"\n";
		if(a[flag]>r)
		cout<<flag-1<<"\n";
	}
	return 0;
}

B. Turtle and an Infinite Sequence

题解:这题怎么说呢?其实说难也难,说简单也简单,难就难在你不好找这个结论,简单就在于他真的只是一个二进制的异或运算,只不过需要一点点技巧来节约时间复杂度,结论就是对于最后一个数m次之后的值应该为(n-m,n+m)这个区间里面所有数的异或

cpp 复制代码
#include<bits/stdc++.h>
using namespace std;
#define int long long
int t;
int n,m;         
signed main() 
{
	cin>>t;
    while(t--)
    {
    	cin >> n >> m;
	    int l = max(0LL , n - m);
	    int r = n + m;
	    int ans = 0;
        long long cnt = 0; 
        while(l != r)
        {
            cnt++;
            l >>= 1;
            r >>= 1;
        }
        while(cnt--) r = (r<<1)^1;
        cout << r << endl;
    }
    return 0;
}
相关推荐
碧海银沙音频科技研究院37 分钟前
基于炬芯ATS3089X自研AEC声学回声消除算法
算法
通问AI1 小时前
在两台 Mac Studio 上跑 800B 模型:MLX + RDMA over Thunderbolt 实测与四道门选型法
算法
ZywOo6231 小时前
《算法竞赛进阶指南》0x03 前缀和与差分
算法
Scintilla_y1 小时前
DAY2 滑动窗口
算法·leetcode·散列表
lvwangshu1 小时前
笛卡尔树
算法·图论
026d232 小时前
状态信号只知“其然”不知“其所以然”:变工况机械故障诊断的物理盲区
算法
姜鱼问生2 小时前
备份和服务器在同一台机器上,等于没备份
算法·架构
姜鱼问生2 小时前
别再 chmod 777 了,用 ACL 给它开一扇窗
后端·算法·架构
特立独行的猫a2 小时前
仓颉语言UI开发实战:我用仓颉写了个桌面版力扣
算法·leetcode·ui·tauri·仓颉·cj-tarui
y1su2 小时前
Leetcode 动态规划 模板
java·数据结构·算法·leetcode·动态规划